| Home · All Classes · All Namespaces · Modules · Functions · Files

Public Slots | Signals | Public Member Functions | Static Public Member Functions | Protected Member Functions | List of all members
Tp::Client::ChannelTypeCallInterface Class Reference
Client-side proxies » Channel proxies

`#include <TelepathyQt/Channel>`

Inheritance diagram for Tp::Client::ChannelTypeCallInterface:
[legend]

## Public Slots

QDBusPendingReply | SetRinging (int timeout=-1)
QDBusPendingReply | SetQueued (int timeout=-1)
QDBusPendingReply | Accept (int timeout=-1)
QDBusPendingReply | Hangup (uint reason, const QString &detailedHangupReason, const QString &message, int timeout=-1)
QDBusPendingReply< QDBusObjectPath > | AddContent (const QString &contentName, uint contentType, uint initialDirection, int timeout=-1)

## Signals

void | ContentAdded (const QDBusObjectPath &content)
void | ContentRemoved (const QDBusObjectPath &content, const Tp::CallStateReason &reason)
void | CallStateChanged (uint callState, uint callFlags, const Tp::CallStateReason &callStateReason, const QVariantMap &callStateDetails)
void | CallMembersChanged (const Tp::CallMemberMap &flagsChanged, const Tp::HandleIdentifierMap &identifiers, const Tp::UIntList &removed, const Tp::CallStateReason &reason)
Signals inherited from Tp::AbstractInterface
void | propertiesChanged (const QVariantMap &changedProperties, const QStringList &invalidatedProperties)

## Public Member Functions

| ChannelTypeCallInterface (const QString &busName, const QString &objectPath, QObject *parent=0)
| ChannelTypeCallInterface (const QDBusConnection &connection, const QString &busName, const QString &objectPath, QObject *parent=0)
| ChannelTypeCallInterface (Tp::DBusProxy *proxy)
| ChannelTypeCallInterface (const Tp::Client::ChannelInterface &mainInterface)
| ChannelTypeCallInterface (const Tp::Client::ChannelInterface &mainInterface, QObject *parent)
Tp::PendingVariant * | requestPropertyContents () const
Tp::PendingVariant * | requestPropertyCallStateDetails () const
Tp::PendingVariant * | requestPropertyCallState () const
Tp::PendingVariant * | requestPropertyCallFlags () const
Tp::PendingVariant * | requestPropertyCallStateReason () const
Tp::PendingVariant * | requestPropertyHardwareStreaming () const
Tp::PendingVariant * | requestPropertyCallMembers () const
Tp::PendingVariant * | requestPropertyMemberIdentifiers () const
Tp::PendingVariant * | requestPropertyInitialTransport () const
Tp::PendingVariant * | requestPropertyInitialAudio () const
Tp::PendingVariant * | requestPropertyInitialVideo () const
Tp::PendingVariant * | requestPropertyInitialAudioName () const
Tp::PendingVariant * | requestPropertyInitialVideoName () const
Tp::PendingVariant * | requestPropertyMutableContents () const
Tp::PendingVariantMap * | requestAllProperties () const
Public Member Functions inherited from Tp::AbstractInterface
virtual | ~AbstractInterface ()
bool | isValid () const
QString | invalidationReason () const
QString | invalidationMessage () const
void | setMonitorProperties (bool monitorProperties)
bool | isMonitoringProperties () const
Public Member Functions inherited from QDBusAbstractInterface
virtual | ~QDBusAbstractInterface ()
bool | isValid () const
QDBusConnection | connection () const
QString | service () const
QString | path () const
QString | interface () const
QDBusError | lastError () const
void | setTimeout (int timeout)
int | timeout () const
QDBusMessage | call (const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusMessage | call (QDBus::CallMode mode, const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusMessage | callWithArgumentList (QDBus::CallMode mode, const QString &method, const QList< QVariant > &args)
bool | callWithCallback (const QString &method, const QList< QVariant > &args, QObject *receiver, const char *returnMethod, const char *errorMethod)
bool | callWithCallback (const QString &method, const QList< QVariant > &args, QObject *receiver, const char *slot)
QDBusPendingCall | asyncCall (const QString &method, const QVariant &arg1, const QVariant &arg2, const QVariant &arg3, const QVariant &arg4, const QVariant &arg5, const QVariant &arg6, const QVariant &arg7, const QVariant &arg8)
QDBusPendingCall | asyncCallWithArgumentList (const QString &method, const QList< QVariant > &args)
Public Member Functions inherited from QObject
| QObject (QObject *parent)
virtual | ~QObject ()
virtual bool | event (QEvent *e)
virtual bool | eventFilter (QObject *watched, QEvent *event)
virtual const QMetaObject * | metaObject () const
QString | objectName () const
void | setObjectName (const QString &name)
bool | isWidgetType () const
bool | signalsBlocked () const
bool | blockSignals (bool block)
QThread * | thread () const
void | moveToThread (QThread *targetThread)
int | startTimer (int interval)
void | killTimer (int id)
T | findChild (const QString &name) const
QList< T > | findChildren (const QString &name) const
QList< T > | findChildren (const QRegExp &regExp) const
QObject * | child (const char *objName, const char *inheritsClass, bool recursiveSearch) const
const QObjectList & | children () const
void | setParent (QObject *parent)
void | installEventFilter (QObject *filterObj)
void | removeEventFilter (QObject *obj)
bool | connect (const QObject *sender, const char *signal, const char *method, Qt::ConnectionType type) const
bool | disconnect (const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *receiver, const char *method)
void | dumpObjectTree ()
void | dumpObjectInfo ()
bool | setProperty (const char *name, const QVariant &value)
QVariant | property (const char *name) const
QList< QByteArray > | dynamicPropertyNames () const
void | destroyed (QObject *obj)
QObject * | parent () const
bool | inherits (const char *className) const
void | deleteLater ()
| QObject (QObject *parent, const char *name)
void | insertChild (QObject *object)
void | removeChild (QObject *object)
bool | isA (const char *className) const
const char * | className () const
const char * | name () const
const char * | name (const char *defaultName) const
void | setName (const char *name)

## Static Public Member Functions

static QLatin1String | staticInterfaceName ()
Static Public Member Functions inherited from QObject
QString | tr (const char *sourceText, const char *disambiguation, int n)
QString | trUtf8 (const char *sourceText, const char *disambiguation, int n)
bool | connect (const QObject *sender, const char *signal, const QObject *receiver, const char *method, Qt::ConnectionType type)
bool | connect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method, Qt::ConnectionType type)
bool | disconnect (const QObject *sender, const char *signal, const QObject *receiver, const char *method)
bool | disconnect (const QObject *sender, const QMetaMethod &signal, const QObject *receiver, const QMetaMethod &method)

## Protected Member Functions

virtual void | invalidate (Tp::DBusProxy *, const QString &, const QString &)
Protected Member Functions inherited from Tp::AbstractInterface
| AbstractInterface (DBusProxy *proxy, const QLatin1String &interface)
| AbstractInterface (const QString &busName, const QString &path, const QLatin1String &interface, const QDBusConnection &connection, QObject *parent)
PendingVariant * | internalRequestProperty (const QString &name) const
PendingOperation * | internalSetProperty (const QString &name, const QVariant &newValue)
PendingVariantMap * | internalRequestAllProperties () const
Protected Member Functions inherited from QObject
QObject * | sender () const
int | senderSignalIndex () const
int | receivers (const char *signal) const
virtual void | timerEvent (QTimerEvent *event)
virtual void | childEvent (QChildEvent *event)
virtual void | customEvent (QEvent *event)
virtual void | connectNotify (const char *signal)
virtual void | disconnectNotify (const char *signal)
bool | checkConnectArgs (const char *signal, const QObject *object, const char *method)

## Additional Inherited Members

Protected Slots inherited from Tp::AbstractInterface
Static Protected Member Functions inherited from QObject
QByteArray | normalizeSignalSlot (const char *signalSlot)
Properties inherited from QObject
| objectName

## Detailed Description

Proxy class providing a 1:1 mapping of the D-Bus interface "org.freedesktop.Telepathy.Channel.Type.Call1".

## Constructor & Destructor Documentation

## § ChannelTypeCallInterface() [1/5]

Tp::Client::ChannelTypeCallInterface::ChannelTypeCallInterface | ( | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ChannelTypeCallInterface associated with the given object on the session bus.

Parameters

  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

## § ChannelTypeCallInterface() [2/5]

Tp::Client::ChannelTypeCallInterface::ChannelTypeCallInterface | ( | const QDBusConnection & | connection,
|  | const QString & | busName,
|  | const QString & | objectPath,
|  | QObject * | parent = `0`
| ) |  |

Creates a ChannelTypeCallInterface associated with the given object on the given bus.

Parameters

  connection | The bus via which the object can be reached.
  busName | Name of the service the object is on.
  objectPath | Path to the object on the service.
  parent | Passed to the parent class constructor.

## § ChannelTypeCallInterface() [3/5]

Tp::Client::ChannelTypeCallInterface::ChannelTypeCallInterface | ( | Tp::DBusProxy * | proxy | ) |

Creates a ChannelTypeCallInterface associated with the same object as the given proxy.

Parameters

  proxy | The proxy to use. It will also be the QObject::parent() for this object.

## § ChannelTypeCallInterface() [4/5]

Tp::Client::ChannelTypeCallInterface::ChannelTypeCallInterface | ( | const Tp::Client::ChannelInterface & | mainInterface | ) |

explicit

Creates a ChannelTypeCallInterface associated with the same object as the given proxy. Additionally, the created proxy will have the same parent as the given proxy.

Parameters

  mainInterface | The proxy to use.

## § ChannelTypeCallInterface() [5/5]

Tp::Client::ChannelTypeCallInterface::ChannelTypeCallInterface | ( | const Tp::Client::ChannelInterface & | mainInterface,
|  | QObject * | parent
| ) |  |

Creates a ChannelTypeCallInterface associated with the same object as the given proxy. However, a different parent object can be specified.

Parameters

  mainInterface | The proxy to use.
  parent | Passed to the parent class constructor.

## Member Function Documentation

## § staticInterfaceName()

static QLatin1String Tp::Client::ChannelTypeCallInterface::staticInterfaceName | ( |  | ) |

inline static

Returns the name of the interface "org.freedesktop.Telepathy.Channel.Type.Call1", which this class represents.

Returns
  The D-Bus interface name.

## § requestPropertyContents()

Tp::PendingVariant* Tp::Client::ChannelTypeCallInterface::requestPropertyContents | ( |  | ) | const

inline

Asynchronous getter for the remote object property `Contents` of type `Tp::ObjectPathList`.

The list of CallContentInterface objects that are part of this call. Change notification is via the ContentAdded() and ContentRemoved() signals.

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestPropertyCallStateDetails()

Tp::PendingVariant* Tp::Client::ChannelTypeCallInterface::requestPropertyCallStateDetails | ( |  | ) | const

inline

Asynchronous getter for the remote object property `CallStateDetails` of type `QVariantMap`.

A map used to provide optional extensible details for the CallState , CallFlags and/or CallStateReason .

Well-known keys and their corresponding value types include:

hangup-message - s
  An optional human-readable message sent when the call was ended, corresponding to the Message argument to the Hangup() method. This is only applicable when the call state is Ended.
  XMPP Jingle can send such messages.
queue-message - s
  An optional human-readable message sent when the local contact is being held in a queue. This is only applicable when Locally_Queued is in the call flags.
  SIP 182 notifications can have human-readable messages attached.
debug-message - s
  A message giving further details of any error indicated by the CallStateReason . This will not normally be localized or suitable for display to users, and is only applicable when the call state is Ended.
balance-required - i
  Optionally included when a call cannot be connected because there is InsufficientBalance, indicating what the required balance would be to place this call. The value of this key has the same units and scale as ConnectionInterfaceBalanceInterface::AccountBalance .
forwarded-to - u
  Optionally included when the CallStateReason is Forwarded. It indicates the handle to whom the Call was forwarded.
forwarded-to-id - s
  The string that would result from inspecting the `forwarded-to` key (i.e. the contact's identifier in the IM protocol).

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestPropertyCallState()

Tp::PendingVariant* Tp::Client::ChannelTypeCallInterface::requestPropertyCallState | ( |  | ) | const

inline

Asynchronous getter for the remote object property `CallState` of type `uint`.

The current high-level state of this call. The CallFlags provide additional information, and the CallStateReason and CallStateDetails explain the reason for the current values for those properties.

Note that when in a conference call, this property is purely to show your state in joining the call. The receiver (or remote contact) in this context is the conference server itself. The property does not change when other call members' states change.

Clients MAY consider unknown values in this property to be an error.

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestPropertyCallFlags()

Tp::PendingVariant* Tp::Client::ChannelTypeCallInterface::requestPropertyCallFlags | ( |  | ) | const

inline

Asynchronous getter for the remote object property `CallFlags` of type `uint`.

Flags representing the status of the call as a whole, providing more specific information than the CallState .

Clients are expected to ignore unknown flags in this property, without error.

When an ongoing call is active and not on hold or has any other problems, this property will be 0.

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestPropertyCallStateReason()

Tp::PendingVariant* Tp::Client::ChannelTypeCallInterface::requestPropertyCallStateReason | ( |  | ) | const

inline

Asynchronous getter for the remote object property `CallStateReason` of type `Tp::CallStateReason`.

The reason for the last change to the CallState and/or CallFlags . The CallStateDetails MAY provide additional information.

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestPropertyHardwareStreaming()

Tp::PendingVariant* Tp::Client::ChannelTypeCallInterface::requestPropertyHardwareStreaming | ( |  | ) | const

inline

Asynchronous getter for the remote object property `HardwareStreaming` of type `bool`.

If this property is True, all of the media streaming is done by some mechanism outside the scope of Telepathy.

A connection manager might be intended for a specialized hardware device, which will take care of the audio streaming (e.g. telepathy-ring, which uses GSM hardware which does the actual audio streaming for the call).

If this is False, the handler is responsible for doing the actual media streaming for at least some contents itself. Those contents will have the CallContentInterfaceMediaInterface interface, to communicate the necessary information to a streaming implementation. Connection managers SHOULD operate like this, if possible.

Many connection managers (such as telepathy-gabble) only do the call signalling, and expect the client to do the actual streaming using something like Farsight, to improve latency and allow better UI integration.

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestPropertyCallMembers()

Tp::PendingVariant* Tp::Client::ChannelTypeCallInterface::requestPropertyCallMembers | ( |  | ) | const

inline

Asynchronous getter for the remote object property `CallMembers` of type `Tp::CallMemberMap`.

A mapping from the remote contacts that are part of this call to flags describing their status. This mapping never has the local user's handle as a key.

When the call ends, this property should be an empty list, and notified with CallMembersChanged()

If the Call implements ChannelInterfaceGroupInterface and the Group members are channel-specific handles, then this call SHOULD also use channel-specific handles.

Anonymous members are exposed as channel-specific handles with no owner.

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestPropertyMemberIdentifiers()

Tp::PendingVariant* Tp::Client::ChannelTypeCallInterface::requestPropertyMemberIdentifiers | ( |  | ) | const

inline

Asynchronous getter for the remote object property `MemberIdentifiers` of type `Tp::HandleIdentifierMap`.

The string identifiers for handles mentioned in CallMembers, to give clients the minimal information necessary to create contacts without waiting for round-trips.

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestPropertyInitialTransport()

Tp::PendingVariant* Tp::Client::ChannelTypeCallInterface::requestPropertyInitialTransport | ( |  | ) | const

inline

Asynchronous getter for the remote object property `InitialTransport` of type `uint`.

If set on a requested channel, this indicates the transport that should be used for this call. Where not applicable, this property is defined to be Unknown, in particular, on CMs with hardware streaming.

When implementing a voip gateway one wants the outgoing leg of the gatewayed to have the same transport as the incoming leg. This property allows the gateway to request a Call with the right transport from the CM.

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestPropertyInitialAudio()

Tp::PendingVariant* Tp::Client::ChannelTypeCallInterface::requestPropertyInitialAudio | ( |  | ) | const

inline

Asynchronous getter for the remote object property `InitialAudio` of type `bool`.

If set to True in a channel request that will create a new channel, the connection manager should immediately attempt to establish an audio stream to the remote contact, making it unnecessary for the client to call ChannelTypeCallInterface::AddContent() .

If this property, or InitialVideo, is passed to EnsureChannel (as opposed to CreateChannel), the connection manager SHOULD ignore these properties when checking whether it can return an existing channel as suitable; these properties only become significant when the connection manager has decided to create a new channel.

If True on a requested channel, this indicates that the audio stream has already been requested and the client does not need to call RequestStreams, although it MAY still do so.

If True on an unrequested (incoming) channel, this indicates that the remote contact initially requested an audio stream; this does not imply that that audio stream is still active (as indicated by ChannelTypeCallInterface::Contents ).

The name of this new content can be decided by using the InitialAudioName property.

Connection managers that support the ConnectionInterfaceContactCapabilitiesInterface interface SHOULD represent the capabilities of receiving audio and/or video calls by including a channel class in a contact's capabilities with ChannelType = Call in the fixed properties dictionary, and InitialAudio and/or InitialVideo in the allowed properties list. Clients wishing to discover whether a particular contact is likely to be able to receive audio and/or video calls SHOULD use this information.

Not all clients support video calls, and it would also be possible (although unlikely) to have a client which could only stream video, not audio.

Clients that are willing to receive audio and/or video calls SHOULD include the following among their channel classes if calling ConnectionInterfaceContactCapabilitiesInterface::UpdateCapabilities() (clients of a ChannelDispatcherInterface SHOULD instead arrange for the ChannelDispatcher to do this, by including the filters in their ClientHandlerInterface::HandlerChannelFilter properties):

- { ChannelType = Call }
- { ChannelType = Call, InitialAudio = True } if receiving calls with audio is supported
- { ChannelType = Call, InitialVideo = True } if receiving calls with video is supported

Connection managers for protocols with capability discovery, like XMPP, need this information to advertise the appropriate capabilities for their protocol.

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestPropertyInitialVideo()

Tp::PendingVariant* Tp::Client::ChannelTypeCallInterface::requestPropertyInitialVideo | ( |  | ) | const

inline

Asynchronous getter for the remote object property `InitialVideo` of type `bool`.

The same as InitialAudio , but for a video stream. This property is immutable (cannot change).

In particular, note that if this property is False, this does not imply that an active video stream has not been added, only that no video stream was active at the time the channel appeared.

This property is the correct way to discover whether connection managers, contacts etc. support video calls; it appears in capabilities structures in the same way as InitialAudio.

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestPropertyInitialAudioName()

Tp::PendingVariant* Tp::Client::ChannelTypeCallInterface::requestPropertyInitialAudioName | ( |  | ) | const

inline

Asynchronous getter for the remote object property `InitialAudioName` of type `QString`.

If InitialAudio is set to True, then this property will name the intial audio content with the value of this property.

Content names are meant to be significant, but if no name can be given to initial audio content, then its name cannot be meaningful or even localized.

If this property is empty or missing from the channel request and InitialAudio is True, then the CM must come up with a sensible for the content, such as "audio".

If the protocol has no concept of stream names then this property will not show up in the allowed properties list of the Requestable Channel Classes for call channels.

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestPropertyInitialVideoName()

Tp::PendingVariant* Tp::Client::ChannelTypeCallInterface::requestPropertyInitialVideoName | ( |  | ) | const

inline

Asynchronous getter for the remote object property `InitialVideoName` of type `QString`.

The same as InitialAudioName , but for a video stream created by setting InitialVideo to True. This property is immutable and so cannot change.

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestPropertyMutableContents()

Tp::PendingVariant* Tp::Client::ChannelTypeCallInterface::requestPropertyMutableContents | ( |  | ) | const

inline

Asynchronous getter for the remote object property `MutableContents` of type `bool`.

If True, a stream of a different content type can be added after the Channel has been requested

If this property is missing, clients SHOULD assume that it is False, and thus that the channel's streams cannot be changed once the call has started.

If this property isn't present in the "allowed" set in any of the Call entries contact capabilities, then user interfaces MAY choose to show a separate "call" option for each class of call.

For example, once an audio-only Google Talk call has started, it is not possible to add a video stream; both audio and video must be requested at the start of the call if video is desired. User interfaces may use this pseudo-capability as a hint to display separate "Audio call" and "Video call" buttons, rather than a single "Call1" button with the option to add and remove video once the call has started for contacts without this flag.

Returns
  A pending variant which will emit finished when the property has been retrieved.

## § requestAllProperties()

Tp::PendingVariantMap* Tp::Client::ChannelTypeCallInterface::requestAllProperties | ( |  | ) | const

inline

Request all of the DBus properties on the interface.

Returns
  A pending variant map which will emit finished when the properties have been retrieved.

## § SetRinging

QDBusPendingReply Tp::Client::ChannelTypeCallInterface::SetRinging | ( | int | timeout = `-1` | ) |

inline slot

Begins a call to the D-Bus method `SetRinging` on the remote object.

Indicate that the local user has been alerted about the incoming call.

This method is only useful if the channel's ChannelInterface::Requested property is False, and the CallState is Initialised (an incoming call is ready and waiting for the user to be notified). Calling this method SHOULD set CallFlags ' bit Locally_Ringing, and notify the remote contact that the local user has been alerted (if the protocol supports this); repeated calls to this method SHOULD succeed, but have no further effect.

In all other states, this method SHOULD fail with the error NotAvailable.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  timeout | The timeout in milliseconds.

## § SetQueued

QDBusPendingReply Tp::Client::ChannelTypeCallInterface::SetQueued | ( | int | timeout = `-1` | ) |

inline slot

Begins a call to the D-Bus method `SetQueued` on the remote object.

Notifies the CM that the local user is already in a call, so this call has been put in a call-waiting style queue.

This method is only useful if the channel's ChannelInterface::Requested property is False, and the CallState is Initialising or Initialised. Calling this method SHOULD set CallFlags ' bit Locally_Queued, and notify the remote contact that the call is in a queue (if the protocol supports this); repeated calls to this method SHOULD succeed, but have no further effect.

Locally_Queued is a little like Locally_Held, but applies to calls that have not been Accepted (the Locally_Queued flag should be unset by the CM when Accept is called). It should also be set in response to the state of the world, rather than in response to user action.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  timeout | The timeout in milliseconds.

## § Accept

QDBusPendingReply Tp::Client::ChannelTypeCallInterface::Accept | ( | int | timeout = `-1` | ) |

inline slot

Begins a call to the D-Bus method `Accept` on the remote object.

For incoming calls in state Initialised, accept the incoming call. This changes the CallState to Accepted.

For outgoing calls in state Pending_Initiator, actually call the remote contact; this changes the CallState to Initialising.

Otherwise, this method SHOULD fail with the error NotAvailable.

This method should be called exactly once per Call, by whatever client (user interface) is handling the channel.

When this method is called, for each CallContentInterface whose CallContentInterface::Disposition is Initial, any streams where the CallStreamInterface::LocalSendingState is Pending_Send will be moved to Sending as if CallStreamInterface::SetSending() (True) had been called.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  timeout | The timeout in milliseconds.

## § Hangup

QDBusPendingReply Tp::Client::ChannelTypeCallInterface::Hangup | ( | uint | reason,
|  | const QString & | detailedHangupReason,
|  | const QString & | message,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `Hangup` on the remote object.

Request that the call is ended. All contents will be removed from the Call so that the Contents property will be the empty list.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  reason

      A generic hangup reason.

  detailedHangupReason

      A more specific reason for the call hangup, if one is available, or
      an empty string otherwise.

  message

      A human-readable message to be sent to the remote contact(s). XMPP
      Jingle allows calls to be terminated with a human-readable message.

  timeout | The timeout in milliseconds.

## § AddContent

QDBusPendingReply<QDBusObjectPath> Tp::Client::ChannelTypeCallInterface::AddContent | ( | const QString & | contentName,
|  | uint | contentType,
|  | uint | initialDirection,
|  | int | timeout = `-1`
| ) |  |

inline slot

Begins a call to the D-Bus method `AddContent` on the remote object.

Request that a new Content of type Content_Type is added to the Call1. Handlers should check the value of the MutableContents property before trying to add another content as it might not be allowed.

Note that timeout is ignored as of now. It will be used once http://bugreports.qt.nokia.com/browse/QTBUG-11775 is fixed.

Parameters

  contentName

      The suggested name of the content to add. The content name property
      should be meaningful, so should be given a name which is
      significant to the user. The name could be a localized
      &quot;audio&quot;, &quot;video&quot; or perhaps include some string
      identifying the source, such as a webcam identifier. If there is
      already a content with the same name as this property then a
      sensible suffix should be added. For example, if this argument is
      &quot;audio&quot; but a content of the same name already exists, a
      sensible suffix such as &quot; (1)&quot; is appended to name the
      new content &quot;audio (1)&quot;. A further content with the name
      &quot;audio&quot; would then be named &quot;audio (2)&quot;.

  contentType

      The media stream type of the content to be added to the call.

  initialDirection

      The requested initial direction of the new content.

  timeout | The timeout in milliseconds.

Returns

      Path to the newly-created Call1.Content object.

## § ContentAdded

void Tp::Client::ChannelTypeCallInterface::ContentAdded | ( | const QDBusObjectPath & | content | ) |

signal

Represents the signal `ContentAdded` on the remote object.

Emitted when a new CallContentInterface is added to the call.

Parameters

  content

      Path to the newly-created Content object.

## § ContentRemoved

void Tp::Client::ChannelTypeCallInterface::ContentRemoved | ( | const QDBusObjectPath & | content,
|  | const Tp::CallStateReason & | reason
| ) |  |

signal

Represents the signal `ContentRemoved` on the remote object.

Emitted when a CallContentInterface is removed from the call.

Parameters

  content

      The Content which was removed.

  reason

      Why the content was removed.

## § CallStateChanged

void Tp::Client::ChannelTypeCallInterface::CallStateChanged | ( | uint | callState,
|  | uint | callFlags,
|  | const Tp::CallStateReason & | callStateReason,
|  | const QVariantMap & | callStateDetails
| ) |  |

signal

Represents the signal `CallStateChanged` on the remote object.

Emitted when the state of the call as a whole changes.

This signal is emitted for any change in the properties corresponding to its arguments, even if the other properties referenced remain unchanged.

Parameters

  callState

      The new value of the CallState property.

  callFlags

      The new value of the CallFlags property.

  callStateReason

      The new value of the CallStateReason property.

  callStateDetails

      The new value of the CallStateDetails property.

## § CallMembersChanged

void Tp::Client::ChannelTypeCallInterface::CallMembersChanged | ( | const Tp::CallMemberMap & | flagsChanged,
|  | const Tp::HandleIdentifierMap & | identifiers,
|  | const Tp::UIntList & | removed,
|  | const Tp::CallStateReason & | reason
| ) |  |

signal

Represents the signal `CallMembersChanged` on the remote object.

Emitted when the CallMembers property changes in any way, either because contacts have been added to the call, contacts have been removed from the call, or contacts' flags have changed.

Parameters

  flagsChanged

      A map from members of the call to their new call member flags,
      including at least the members who have been added to CallMembers,
      and the members whose flags have changed.

  identifiers | The identifiers of the contacts in the Flags_Changed map.

  removed

      A list of members who have left the call, i.e. keys to be removed
      from CallMembers.

  reason

      A structured reason for the change.

## § invalidate()

void Tp::Client::ChannelTypeCallInterface::invalidate | ( | Tp::DBusProxy * | proxy,
|  | const QString & | error,
|  | const QString & | message
| ) |  |

protected virtual

Reimplemented from Tp::AbstractInterface.